<template>
  <div class="fr-grid-row fr-grid-row--gutters fr-px-2w">
    <div class="fr-col-12">
      <StatsFilters
        :follow-up-type-options="followUpTypeOptions"
        :beneficiaries-cities-options="beneficiariesCitiesOptions"
        :agent-options="agentOptions"
        id-prefix="beneficiaries"
        @filter="onFilter"
      />
    </div>
    <h2 class="fr-col-12 stats-main-title">
      {{ beneficiaryCountLabel }}
    </h2>
    <AtomAlert
      v-if="error"
      :alert-type="AlertType.Error"
      message="Le nombre total de bénéficiaires n'a pas pu être chargé."
    />
    <AtomLoader
      v-if="pending"
      class="fr-mx-auto"
    />
    <template v-else-if="beneficiaryCount">
      <div class="fr-col-12 fr-col-md-6 fr-col-xl-3">
        <StatsGender
          :beneficiary-count="beneficiaryCount"
          :filters="filters"
        />
      </div>
      <div class="fr-col-12 fr-col-md-6 fr-col-xl-3">
        <StatsAgeGroups
          :beneficiary-count="beneficiaryCount"
          :filters="filters"
        />
      </div>
      <div class="fr-col-12 fr-col-lg-6">
        <StatsFamilySituations
          :beneficiary-count="beneficiaryCount"
          :filters="filters"
        />
      </div>
      <div class="fr-col-12 fr-col-lg-6 fr-col-xl-4">
        <StatsRegions
          :beneficiary-count="beneficiaryCount"
          :filters="filters"
        />
      </div>
      <div
        v-if="isMinistryAgent"
        class="fr-col-12 fr-col-lg-6 fr-col-xl-4"
      >
        <StatsAccommodationZone
          :beneficiary-count="beneficiaryCount"
          :filters="filters"
        />
      </div>
      <div
        v-if="isMinistryAgent"
        class="fr-col-12 fr-col-lg-6 fr-col-xl-4"
      >
        <StatsAccommodationMode
          :beneficiary-count="beneficiaryCount"
          :filters="filters"
        />
      </div>
      <div class="fr-col-12 fr-col-lg-6 fr-col-xl-4">
        <StatsMobility
          :beneficiary-count="beneficiaryCount"
          :filters="filters"
        />
      </div>
      <div class="fr-col-12 fr-col-lg-6 fr-col-xl-4">
        <StatsCSP
          :beneficiary-count="beneficiaryCount"
          :filters="filters"
        />
      </div>
      <template v-if="isMinistryAgent">
        <div class="fr-col-12 fr-col-lg-6 fr-col-xl-4">
          <StatsMinistereStructure
            :beneficiary-count="beneficiaryCount"
            :filters="filters"
          />
        </div>
        <div class="fr-col-12 fr-col-lg-6 fr-col-xl-4">
          <StatsMinistereDepartementService
            :beneficiary-count="beneficiaryCount"
            :filters="filters"
          />
        </div>
        <div class="fr-col-12 fr-col-lg-6 fr-col-xl-4">
          <StatsMinistereCategorie
            :beneficiary-count="beneficiaryCount"
            :filters="filters"
          />
        </div>
      </template>
    </template>
  </div>
</template>

<script setup>
  import { AlertType } from '~~/utils/constants/alert'
  import { errorResponseMessage } from '~~/utils/errorResponse'
  import { prepareBeneficiaryFilters } from '~/utils/stats'

  const { $getItems } = useNuxtApp()

  const isMinistryAgent = useMinistryAgent()

  defineProps({
    followUpTypeOptions: {
      type: Map,
      default: null
    },
    beneficiariesCitiesOptions: {
      type: Map,
      default: null
    },
    agentOptions: {
      type: Map,
      default: null
    }
  })

  const {
    data: beneficiaryCount,
    pending,
    error,
    refresh
  } = useLazyAsyncData('beneficiaryCount', loadBeneficiaryCount, {
    server: false,
    default: () => 0
  })

  const filters = ref({})

  const beneficiaryCountLabel = computed(
    () =>
      `${beneficiaryCount.value} ${
        beneficiaryCount.value > 1 ? 'Bénéficiaires' : 'Bénéficiaire'
      }`
  )

  watch(filters, refresh)

  async function loadBeneficiaryCount() {
    // NOTE: It is not using `count` agreggation due to a Directus bug - See https://github.com/directus/directus/discussions/16992
    const res = await $getItems('beneficiary', {
      aggregate: { countDistinct: 'id' },
      filter: filters.value
    })

    if (res.status === 200) {
      return parseInt(res.data.data[0].countDistinct.id)
    }
    throw new Error(errorResponseMessage(res))
  }

  function onFilter(newFilters) {
    filters.value = prepareBeneficiaryFilters(newFilters)
  }
</script>
